Skip to main content Skip to footer

Apply Custom Styling to a Specific OLAP PivotGrid Column in React

Specific Olap Columns Styled

Background

The Wijmo OLAP PivotGrid is built on top of the FlexGrid control. Because the pivot grid generates its output columns dynamically from the PivotEngine, adding a style object directly to a field or column definition will not apply custom formatting to the rendered pivot cells.

To style a specific OLAP value field, such as an Allowance column, use the formatItem event. This event provides access to each rendered cell so you can inspect the pivot column, identify the value field, and apply custom CSS.

Steps to Complete

  1. Install and import the Wijmo React OLAP packages.
  2. Create a PivotEngine with the fields used in the pivot view.
  3. Add CSS classes for the custom column styling.
  4. Use the formatItem event to identify the Allowance value field.
  5. Render the PivotGrid
  6. Optionally use getKeys to inspect the row and column context for each pivot cell.

Getting Started

Install and import the Wijmo React OLAP packages

npm install @mescius/wijmo @mescius/wijmo.olap @mescius/wijmo.react.olap @mescius/wijmo.styles
import React, { useCallback, useMemo } from 'react';
import '@mescius/wijmo.styles/wijmo.css';
import { PivotEngine } from '@mescius/wijmo.olap';
import { PivotGrid } from '@mescius/wijmo.react.olap';
  • The React OLAP package provides the PivotGrid component, while PivotEngine defines the pivot view.

 

Create a PivotEngine with the fields used in the pivot view

const pivotEngine = useMemo(() => {
  return new PivotEngine({
    itemsSource: getData(),
    fields: [
      { binding: 'region', header: 'Region' },
      { binding: 'product', header: 'Product' },
      { binding: 'sales', header: 'Sales', format: 'n2' },
      { binding: 'allowance', header: 'Allowance', format: 'n2' }
    ],
    rowFields: ['Region'],
    columnFields: ['Product'],
    valueFields: ['Sales', 'Allowance']
  });
}, []);
  • When adding fields to rowFields, columnFields, or valueFields by string, use the field header. You can still compare against the original data property by checking the field’s binding.

 

Add CSS classes for the custom column styling

.allowance-cell {
  background-color: #fff3cd;
  color: #856404;
  font-weight: 700;
}

.allowance-header {
  background-color: #ffe69c;
  color: #664d03;
  font-weight: 700;
}
  • Using CSS classes keeps the formatting easier to maintain than setting several inline styles in the event handler.

 

Use the formatItem event to identify the Allowance value field

const getValueField = (grid, colIndex) => {
  const valueFields = grid.engine?.valueFields;
  return valueFields?.length
    ? valueFields[colIndex % valueFields.length]
    : null;
};

const formatItem = useCallback((grid, e) => {
  const isDataCell = e.panel === grid.cells;
  const isHeaderCell = e.panel === grid.columnHeaders;

  if (!isDataCell && !isHeaderCell) {
    return;
  }

  e.cell.classList.remove('allowance-cell', 'allowance-header');

  const valueField = getValueField(grid, e.col);
  const isAllowance =
    valueField?.binding === 'allowance' ||
    valueField?.header === 'Allowance';

  if (isAllowance) {
    e.cell.classList.add(isDataCell ? 'allowance-cell' : 'allowance-header');
  }
}, []);
  • The important part is grid.engine.valueFields[e.col % grid.engine.valueFields.length]. PivotGrid column bindings are generated for the pivot output, so the rendered column’s binding is not always the same as the original data field. The value field collection gives you the original PivotField, including its binding and header.

  • Because grid cells are recycled as the user scrolls, always remove or reset custom styles before applying them.

 

Render the PivotGrid

export default function App() {
  const pivotEngine = useMemo(() => {
    return new PivotEngine({
      itemsSource: getData(),
      fields: [
        { binding: 'region', header: 'Region' },
        { binding: 'product', header: 'Product' },
        { binding: 'sales', header: 'Sales', format: 'n2' },
        { binding: 'allowance', header: 'Allowance', format: 'n2' }
      ],
      rowFields: ['Region'],
      columnFields: ['Product'],
      valueFields: ['Sales', 'Allowance']
    });
  }, []);

  return (
    <PivotGrid
      itemsSource={pivotEngine}
      formatItem={formatItem}
    />
  );
}

 

Optionally use getKeys to inspect the row and column context for each pivot cell

const keys = grid.getKeys(e.row, e.col);

console.log({
  generatedBinding: grid.columns[e.col].binding,
  valueFieldBinding: valueField?.binding,
  valueFieldHeader: valueField?.header,
  columnFields: keys?.colKey?.fields,
  columnValues: keys?.colKey?.values
});
  • Use getKeys when you need to style a value field only for a specific pivot column group, such as a certain product, year, region, or other column field value.

 

With this React setup, every rendered Allowance value column receives the custom background color, text color, and font weight.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Apply Custom Styling to a Specific OLAP PivotGrid Column in Vue

Specific OLAP columns styled

Background

The Wijmo OLAP PivotGrid extends FlexGrid, so rendered cells should be customized with the formatItem event. Since OLAP columns are generated dynamically by the PivotEngine, adding a style object directly to a field definition will not style the rendered pivot cells.

Steps to Complete

  1. Install and import the Wijmo Vue OLAP packages.
  2. Add CSS classes for the custom column styling.
  3. Create the PivotEngine.
  4. Render the Vue wj-pivot-grid.
  5. Use formatItem to style the target value field.

Getting Started

Install and import the Wijmo Vue OLAP packages

npm install @mescius/wijmo.vue2.olap @mescius/wijmo.olap @mescius/wijmo.grid @mescius/wijmo.styles

In App.vue, import the Vue OLAP component and the core PivotEngine:

<script setup>
import { WjPivotGrid } from '@mescius/wijmo.vue2.olap';
import { PivotEngine } from '@mescius/wijmo.olap';
</script>
  • The wijmo.vue2.olap package provides Vue components for Wijmo OLAP controls. Despite the package name, it supports Vue 2 and Vue 3.

 

Add CSS classes for the custom column styling

Add Wijmo styles and your custom classes to a global stylesheet, such as src/style.css:

@import '@mescius/wijmo.styles/wijmo.css';

.allowance-cell {
  background-color: #fff3cd;
  color: #856404;
  font-weight: 700;
}

.allowance-header {
  background-color: #ffe69c;
  color: #664d03;
  font-weight: 700;
}
  • Avoid placing these styles in a scoped Vue style block because Wijmo creates and recycles grid cell elements dynamically.

 

Create the PivotEngine

<script setup>
import { WjPivotGrid } from '@mescius/wijmo.vue2.olap';
import { PivotEngine } from '@mescius/wijmo.olap';

const pivotEngine = new PivotEngine({
  itemsSource: getData(),
  fields: [
    { binding: 'region', header: 'Region' },
    { binding: 'product', header: 'Product' },
    { binding: 'sales', header: 'Sales', format: 'n2' },
    { binding: 'allowance', header: 'Allowance', format: 'n2' }
  ],
  rowFields: ['Region'],
  columnFields: ['Product'],
  valueFields: ['Sales', 'Allowance']
});
</script>
  • The PivotEngine defines the available fields and current OLAP layout. When adding fields to rowFields, columnFields, or valueFields by string, use the field header.

 

Render the Vue wj-pivot-grid

<template>
  <wj-pivot-grid
    :itemsSource="pivotEngine"
    :formatItem="formatItem" />
</template>
  • The itemsSource is set to the PivotEngine. The formatItem handler is called each time the grid creates or updates a cell.

 

Use formatItem to style the target value field

<script setup>
function getValueField(grid, colIndex) {
  const valueFields = grid.engine?.valueFields;

  return valueFields?.length
    ? valueFields[colIndex % valueFields.length]
    : null;
}

function formatItem(grid, e) {
  const isDataCell = e.panel === grid.cells;
  const isHeaderCell = e.panel === grid.columnHeaders;

  if (!isDataCell && !isHeaderCell) {
    return;
  }

  e.cell.classList.remove('allowance-cell', 'allowance-header');

  const valueField = getValueField(grid, e.col);
  const isAllowance =
    valueField?.binding === 'allowance' ||
    valueField?.header === 'Allowance';

  if (isAllowance) {
    e.cell.classList.add(isDataCell ? 'allowance-cell' : 'allowance-header');
  }
}
</script>
  • PivotGrid columns are generated from the pivot view, so grid.columns[e.col].binding may not match the original source field name. Using grid.engine.valueFields lets you identify the original value field. Also, because cells are recycled, always remove custom classes before applying them again.

 

Optional: inspect pivot keys for more specific styling

const keys = grid.getKeys(e.row, e.col);

console.log({
  generatedBinding: grid.columns[e.col].binding,
  valueFieldBinding: valueField?.binding,
  valueFieldHeader: valueField?.header,
  columnFields: keys?.colKey?.fields,
  columnValues: keys?.colKey?.values
});
  • Use getKeys when you need to style Allowance only for a specific pivot column group, such as a product, year, or region.

 

With this setup, every rendered Allowance value column receives the custom background color, text color, and font weight.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Apply Custom Styling to a Specific OLAP PivotGrid Column in Angular

Specific OLAP columns styled

Background

The Wijmo OLAP PivotGrid is built on top of the FlexGrid control. Because the pivot grid generates its output columns dynamically from the PivotEngine, adding a style object directly to a field or column definition will not apply custom formatting to the rendered pivot cells.

To style a specific OLAP value field, such as an Allowance column, use the formatItem event. This event lets you inspect each rendered cell, identify the pivot value field, and apply custom CSS.

Steps to Complete

  1. Install and import the Wijmo Angular OLAP packages.
  2. Add CSS classes for the custom column styling.
  3. Create the PivotEngine.
  4. Render the Angular wj-pivot-grid.
  5. Use formatItem to style the target value field.

Getting Started

Install and import the Wijmo Angular OLAP packages

npm install @mescius/wijmo.angular2.olap @mescius/wijmo.olap @mescius/wijmo.grid @mescius/wijmo.styles

Import the Angular OLAP module and core OLAP/Grid APIs in app.component.ts:

import { Component } from '@angular/core';
import { WjOlapModule, WjPivotGrid } from '@mescius/wijmo.angular2.olap';
import { PivotEngine } from '@mescius/wijmo.olap';
import { FormatItemEventArgs } from '@mescius/wijmo.grid';
  • The Angular package provides the wj-pivot-grid component. The core PivotEngine creates the pivot view, and FormatItemEventArgs provides access to the rendered cell.

 

Add CSS classes for the custom column styling

Add the Wijmo stylesheet and your custom classes to src/styles.css:

@import '@mescius/wijmo.styles/wijmo.css';

.allowance-cell {
  background-color: #fff3cd;
  color: #856404;
  font-weight: 700;
}

.allowance-header {
  background-color: #ffe69c;
  color: #664d03;
  font-weight: 700;
}
  • These classes define the custom background color, text color, and font weight. Use global CSS because Wijmo creates and recycles grid cell elements dynamically.

 

Create the PivotEngine

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [WjOlapModule],
  templateUrl: './app.component.html'
})
export class AppComponent {
  pivotEngine = new PivotEngine({
    itemsSource: getData(),
    fields: [
      { binding: 'region', header: 'Region' },
      { binding: 'product', header: 'Product' },
      { binding: 'sales', header: 'Sales', format: 'n2' },
      { binding: 'allowance', header: 'Allowance', format: 'n2' }
    ],
    rowFields: ['Region'],
    columnFields: ['Product'],
    valueFields: ['Sales', 'Allowance']
  });
}
  • The PivotEngine defines the available fields and the current pivot layout. When adding fields to rowFields, columnFields, or valueFields by string, use the field header.

 

Render the Angular wj-pivot-grid

Add the grid to app.component.html:

<wj-pivot-grid
  #pivotGrid
  [itemsSource]="pivotEngine"
  (formatItem)="formatItem(pivotGrid, $event)">
</wj-pivot-grid>
  • The itemsSource is set to the PivotEngine. The #pivotGrid template variable passes the grid instance into the formatItem handler, while $event contains the cell formatting event arguments.

 

Use formatItem to style the target value field

private getValueField(grid: WjPivotGrid, colIndex: number) {
  const valueFields = grid.engine?.valueFields;

  return valueFields?.length
    ? valueFields[colIndex % valueFields.length]
    : null;
}

formatItem(grid: WjPivotGrid, e: FormatItemEventArgs) {
  const isDataCell = e.panel === grid.cells;
  const isHeaderCell = e.panel === grid.columnHeaders;

  if (!isDataCell && !isHeaderCell) {
    return;
  }

  e.cell.classList.remove('allowance-cell', 'allowance-header');

  const valueField = this.getValueField(grid, e.col);
  const isAllowance =
    valueField?.binding === 'allowance' ||
    valueField?.header === 'Allowance';

  if (isAllowance) {
    e.cell.classList.add(isDataCell ? 'allowance-cell' : 'allowance-header');
  }
}
  • PivotGrid columns are generated from the pivot view, so grid.columns[e.col].binding may not match the original source field name. The safest way to identify the displayed value field is to use grid.engine.valueFields. Also, because grid cells are recycled, remove the custom classes before applying them again.

 

Optional: inspect pivot keys for more specific styling

const keys = grid.getKeys(e.row, e.col);

console.log({
  valueField: valueField?.binding,
  columnFields: keys?.colKey?.fields,
  columnValues: keys?.colKey?.values
});
  • Use getKeys when you need to style Allowance only for a specific pivot column group, such as a particular product, year, or region.

 

With this setup, every rendered Allowance value column receives the custom background color, text color, and font weight.

Happy coding!

Andrew Peterson

Technical Engagement Engineer